<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<form [formGroup]="uploadForm" novalidate>
  <input id="uploadFile"
         type="file"
         #fileInput
         ngFileSelect
         [options]="options"
         (uploadOutput)="onUploadOutput($event)"
         [uploadInput]="uploadInput"
         [accept]="fileAccept">

  <div fxLayout fxLayoutGap="25px" class="file-input">
    <button mat-button fxFlex="none"
            id="browseButton"
            color="primary"
            [disabled]="uploadInProgress"
            (click)="fileInput.click()">
      <mat-icon>attach_file</mat-icon>&nbsp;{{"global.actions.browse" | translate | uppercase}}
    </button>

    <mat-form-field fxFlex fxFlexAlign="auto">
      <input matInput
             formControlName="uploadFile"
             [placeholder]="placeholder | translate"
             [value]="file?.nativeFile?.name"
             readonly
             required
             (click)="fileInput.click()"/>
      <mat-error *ngIf="uploadForm.get('uploadFile').touched && uploadForm.get('uploadFile').hasError('required')">
        <span>{{'global.forms.errors.required' | translate}}</span>
      </mat-error>
      <mat-error *ngIf="uploadForm.get('uploadFile').touched && uploadForm.get('uploadFile').hasError('invalidFile')">
        <span id="business-error">{{uploadForm.get('uploadFile').getError('invalidFile').message}}</span>
      </mat-error>
    </mat-form-field>

    <button mat-raised-button fxFlex="none"
            id="uploadButton"
            color="primary"
            [disabled]="!file || uploadInProgress"
            (click)="preview()">
      <mat-icon>{{uploadIcon}}</mat-icon>&nbsp;{{uploadText | translate | uppercase}}
    </button>

  </div>

  <div class="upload-progress" fxLayout="column" fxLayoutGap="10px"
       *ngIf="uploadInProgress">
    <span class="upload-progress-percent">{{progressText | translate}}: {{uploadProgress.percent}} %</span>
    <mat-progress-bar mode="determinate" [value]="uploadProgress.percent"></mat-progress-bar>
    <span>{{timeLeft}}</span>
  </div>
</form>
